#!/bin/sh
#----------------------------------------------------------------------
#
# livescore.sh
#
# V2.0a
#
# Ermittelt alle Fussball Spielstände des aktuellen Tages
#
# Quelle: http://xml.scorespro.com/wettbasis/
#
# Aufruf ueber das Flexmenu Plugin
#
# Dazu Eintrag in der shellexec.conf:
#
# ACTION=&Fu~zball Livescores, ( /var/plugins/livescore.sh makemainmenu ; if [ -f /tmp/livescore_main.inc ] ; then /var/plugins/shellexec /tmp/livescore_main.inc ; rm /tmp/livescore* ; else msgbox popup='Fehler, Men~u wurde nicht erzeugt.' timeout=5 ;fi )
#
# V2.0a Fehler in der Ermittlung der Livespiele gefixt
#       Tabellenausgabe msgbox size=20 bei mehr als 24 Mannschaften
#
# Author: barabas
#-------------------------------------------------------------------------

#comp="205|02-22|ENGLAND - League One|11|0|GERMANY - Bundesliga|71|0|GERMANY - 2. Bundesliga|207|0|FRANCE - Ligue 2|68|0|PORTUGAL - bwin Liga|16|0|NETHERLANDS - Eredivisie|91|0|NETHERLANDS - Jupiler League|17|0|TURKEY - Super Lig|63|0|BELGIUM - Jupiler League|62|0|AUSTRIA - T-Mobile Bundesliga|212|0|CROATIA - HNL Ozujsko|0|0|FINLAND - Liiga Cup|65|0|HUNGARY - Borsodi Liga|66|0|POLAND -  Orange Ekstraklasa|754|0|ROMANIA - Liga 1|61|0|ARGENTINA - Torneo Clausura|61|02-23|ARGENTINA - Torneo Clausura|124|0|MEXICO - Clausura|0|02-22|FRIENDLIES|0|0|IRAN - Premier League";
#game=Array("1|20:45|0|Swansea|0|0|Luton|139172|0||0|Hartlepool|0|0|Northampton|139171","17|20:30|0|Bochum|0|0|Hannover|139190","14|18:00|0|Hoffenheim|0|0|Freiburg|139187|15||0|Cologne|0|0|1860 Munchen|139188|16||0|Mainz|0|0|Carl Zeiss Jena|139189","9|20:00|0|Chateauroux|0|0|Boulogne|139181|6||0|Angers|0|0|Niort|139178|12||0|Montpellier|0|0|Guingamp|139184|13||0|Reims|0|0|Troyes|139185|10||0|Clermont|0|0|Gueugnon|139182|8||0|Brest|0|0|Grenoble|139180|7||0|Bastia|0|0|Libourne|139179|5||0|Amiens|0|0|Ajaccio|139177|11|20:30|0|Le Havre|0|0|Dijon|139183","35|21:30|0|Guimaraes|0|0|Naval|139527","20|20:30|0|Sparta Rotterdam|0|0|Utrecht|139193","22|20:00|0|Den Bosch|0|0|Go Ahead Eagles|139195|25||0|Emmen|0|0|Top Oss|139198|24||0|Dordrecht 90|0|0|HFC Haarlem|139197|23||0|ADO Den Haag|0|0|Omniworld|139196|21||0|BV Veendam|0|0|Cambuur Leeuwarden|139194|26||0|Fortuna|0|0|Eindhoven|139199|27||0|Helmond Sport|0|0|RBC Roosendaal|139200|30||0|Zwolle|0|0|MVV Maastricht|139203|29||0|Stormvogels/Telstar|0|0|AGOVV Apeldoorn|139202|28||0|RKC|0|0|Volendam|139201","2|19:00|0|Denizlispor|0|0|Besiktas|139174","4|20:30|0|Genk|0|0|Sint-Truiden|139176","3|19:30|0|Sturm|0|0|LASK Linz|139175","32|17:00|0|Inter-Zapresic|0|0|Zagreb|139327","47|16:00|0|Haka|0|0|Lahti|0|48|17:00|0|Jaro|0|0|Inter Turku|0|46|18:30|0|HJK Helsinki|0|0|Tampere United|0","31|19:00|0|Debrecen|0|0|Diosgyor|139204","19|19:00|0|LKS Lodz|0|0|Jagiellonia|139192|18|20:00|0|Korona|0|0|Wisla Krakow|139191","34|18:00|0|Farul Constanta|0|0|Gloria Buzau|139340|33|19:30|0|Dinamo B|0|0|Ceahlaul Piatra|139339","45|22:00|0|Estudiantes de La Plata|0|0|Newells Old Boys|140356","52|00:15|0|Lanus|0|0|Colon|140363","44|01:00|0|Veracruz|0|0|Toluca|140350","49|14:30|0|FC Kobenhavn (Denmark)|0|0|Viking FK (Norway)|0|50|16:00|0|Aalesund (Norway)|0|0|Rubin (Russia)|0|51|19:00|0|Lyn (Norway)|0|0|Brondby (Denmark)|0","38|11:00|6|Pegah|0|2|Peykan|0|39||6|Saba|0|0|Pas|0|41||6|Sepahan|0|0|Fajr-Sepasi|0|42||6|Shirin Faraz Kermanshah|0|2|Est-Ahvaz|0|40||6|Sanat Naft Abadan|2|0|Aboomoslem|0|37||6|Mes|0|0|Malavan|0|36||6|Bargh|0|0|Zob-Ahan|0|43|13:15|-20|Saipa|0|0|Esteghlal|0");
#st=Array("","1T","HT","2T","ET","11M","FT","FT","Pst","AET","Pen","Ssp");

url="http://xml.scorespro.com/wettbasis/"
details_url="${url}goals.php?f="
tab_url="${url}standings.php?f="

spieldetails_out=/tmp/livescore_spieldetails.out
acttab=/tmp/livescore_tabelle.out
tempfile=/tmp/livescore.tmp
html_out=/tmp/livescore.out
ausgabe_conf=/tmp/livescore_main.inc
ausgabe_inc=/tmp/livescore.inc
sedfile=/tmp/livescore.sed

if [ -e /bin/msgbox ] ; then
	msgbox=/bin/msgbox
		else
	msgbox=/var/bin/msgbox
fi;

tag=`date +%Y-%m-%d`

mainmenutitle="Fu~zball Livescores"
popup="No details found!"
msgtext="   No matches found!"
msgtitle="match details"
prog="$0"

# check echo Fehler busybox v1.0.1
if [ `echo "\r" | grep -c "\r"` -gt 0 ] ; then
  TAB=`echo -e "\t"`
  CRLF=`echo -e "\r"`
  CR=`echo -e "\n"`
else
  TAB=`echo "\t"`
  CRLF=`echo "\r"`
  CR=`echo "\n"`
fi

#---------------------------------------------------------------

makemainmenu () {

echo "LINESPP=12
      FONTSIZE=22
      FONT=/share/fonts/micron_bold.ttf
      WIDTH=620
      HIGHT=500 
      MENU=$mainmenutitle $tag
      INCLUDE=$ausgabe_inc
      ENDMENU" >$ausgabe_conf

}

#---------------------------------------------------------------

make_include () {

      wget -O- $url | sed "s/$CRLF//g
                           s/'//g" >$html_out

      if [ -s $html_out ] ; then

      awk -v prog="$prog" 'BEGIN { }

            /comp=/ {
                      gsub(/comp="/,"")
                      gsub(/";/,"")
                      x=split($0,comp,"|")
                      #print "Anzahl Ligen: " x/3
                    }
           /game=/ {
                      gsub(/game=Array\("/,"")
                      gsub(/");/,"")
                      gsub(/"/,"")
                      y=split($0,ligagames,",")
                      #print "Anzahl Liga Spiele " y
                    }

            END {
                   for(i=0;i<x/3;i++) {

                      m=3*i
                      if(comp[m+3]!=0) {

                         # Liga: ENGLAND - League One
                         #Ligagames: 1|20:45|0|Swansea|0|0|Luton|139172|0||0|Hartlepool|0|0|Northampton|139171
                         #           1   2   3     4   5 6   7      8   1 23     4      5 6      7         8
                         #printf("Liga: %s\n",comp[m+3])
                         #print "Ligagames: " ligagames[i+1]

                         ligaid=comp[m+1]

                         z=split(ligagames[i+1],game,"|")
                         #print "Anzahl Spiele pro Liga  " z/8


                         printf("ENDMENU=%s refresh\nMENU=%s\n",prog,comp[m+3])

                         for(j=0;j<z;j++) {

                           n=8*j

                           # Spielbeginn
                           if(game[n+2] != "") {
                              #print "Spielbeginn: " game[n+2]
                              starttime=game[n+2]
                           }

                           gametime=""
                           # aktuelle Spielzeit
                           if(game[n+3] != "") {

                              if(game[n+3]=="6") {
                                gametime="FT"
                              }
                              if(game[n+3]=="2") {
                                gametime="HT"
                              }

                              c=gsub("-","",game[n+3])
                               if(c > 0) {
                                 #print "Akt. Spielzeit: " game[n+3] " min."
                                 gametime=game[n+3] "\""
                               }

                           }

                          # game id fuer details und tabelle
                          # http://xml.scorespro.com/wettbasis/goals.php?f=17
                          if(game[n+1] != "") {
                             #print "ID: " game[n+1]
                             gameid=game[n+1]
                          }

                          # Spielpaarung
                          if(game[n+4] != "") {
                             # print game[n+4] " " game[n+5] " - " game[n+6] " " game[n+7]
                             gamename=game[n+4] " " game[n+5] " - " game[n+6] " " game[n+7]
                             home=game[n+4] ; guest=game[n+7] ; homegoal=game[n+5] ; guestgoal=game[n+6]

                          # Spielzeit fuer Anzeige msgbox
                          gametime2=gametime
                          gsub(/\"/," min.",gametime2)
                          if (gametime2 == "")
                           gametime2="-"

                             printf("ACTION=&%s %s,%s make_detail %s %s \"%s\" \"%s\" %s %s \"%s\"\n",gametime,gamename,prog,gameid,ligaid,gametime2,home,homegoal,guestgoal,guest)
                             printf("COMMENT=kick off: %s \n",starttime)
                           }

                         }

                      }
                   }

                   printf("ENDMENU=%s refresh\n",prog)

                }' $html_out | sed '1d' >$ausgabe_inc

                # alle Ligen mit aktiven Spielen markieren

               awk 'BEGIN { }
                  $0 ~/MENU=/ {
                               liga=$0
                              }

                   $0 ~/&[0-9]+" / || $0 ~/&HT/ {
                                                   gsub(/MENU=/,"",liga)
                                                   print "s#MENU=" liga "#MENU=~Y" liga "~S#"
                                                   # print "s#" liga "#" liga " [~YLive~S]#"
                                                }

                  $0 ~/ENDMENU/ {
                                  liga=""
                                }' $ausgabe_inc | sort -u >$sedfile

                sed -if $sedfile $ausgabe_inc

      else

        $msgbox title="mainmenutitle" msg='Error, could not create html.out' timeout=10

      fi

}

#---------------------------------------------------------------

make_detail () {

      details_url=$details_url"$1"
      tab_url=$tab_url"$2"
      acttime="$3"
      home="$4"
      homegoal="$5"
      guestgoal="$6"
      guest="$7"

      wget -O- $details_url | sed "# CRLF fix
                                   s/$CRLF//g" >$tempfile

      if [ -s $tempfile ] ; then

            echo "~T150~Y $home~T300 $homegoal  :  $guestgoal~T400 $guest~S\n~s"  >$spieldetails_out

            # Tore
            sed '/<!--goals-->/,/<!--rc-->/!d
                 /<td valign=top>/!d' $tempfile |\
            sed 's/&nbsp;<\/td>/ min.;/g
                 s/&nbsp;//g
                 s/<[^>]*>//g
                 s/;$//g' |\
            sed  '$!N;s/\n/  #  /' |\

            awk '{
                   split($0,feld,"#")
                   x=split(feld[1],home,";")
                   y=split(feld[2],guest,";")
                   for(i=1;i<=x;i++){
                     gsub(/^ */,"",home[i])
                     print home[i]
                   }
                   for(i=1;i<=y;i++){
                     gsub(/^ */,"",guest[i])
                     print "~T380 " guest[i]
                   }

                 }' >>$spieldetails_out

            # yellow cards
            sed '/<!--yc-->/,/<!--penal-->/!d
                 /<td valign=top>/!d' $tempfile |\
            sed 's/&nbsp;<\/td>/ min.;/g
                 s/&nbsp;//g
                 s/<[^>]*>//g
                 s/;$//g' |\
            sed  '$!N;s/\n/  #  /' |\

            awk '{
                   split($0,feld,"#")
                   x=split(feld[1],home,";")
                   y=split(feld[2],guest,";")
                   for(i=1;i<=x;i++){
                     gsub(/^ */,"",home[i])
                     if(home[i] != "")
                       print "~Y#~S " home[i]
                   }
                   for(i=1;i<=y;i++){
                     gsub(/^ */,"",guest[i])
                     if(guest[i] != "")
                       print "~T380 ~Y#~S " guest[i]
                   }

                 }' >>$spieldetails_out

            # red cards
            sed '/<!--rc-->/,/<!--yc-->/!d
                 /<td valign=top>/!d' $tempfile |\
            sed 's/&nbsp;<\/td>/ min.;/g
                 s/&nbsp;//g
                 s/<[^>]*>//g
                 s/;$//g' |\
            sed  '$!N;s/\n/  #  /' |\

            awk '{
                   split($0,feld,"#")
                   x=split(feld[1],home,";")
                   y=split(feld[2],guest,";")
                   for(i=1;i<=x;i++){
                     gsub(/^ */,"",home[i])
                     if(home[i] != "")
                       print "~R#~S " home[i]
                   }
                   for(i=1;i<=y;i++){
                     gsub(/^ */,"",guest[i])
                     if(guest[i] != "")
                       print "~T380 ~R#~S " guest[i]
                   }

                 }' >>$spieldetails_out

            if [ $acttime != "HT" ] && [ $acttime != "FT" ] && [ $acttime != "-" ] ; then
              acttime="$acttime min."
            fi

            echo "\n~s\nact. playing time: $acttime" >>$spieldetails_out

            # Aktuelle Tabelle
            #echo $tab_url >/tmp/ttt

            wget -O- $tab_url | sed "# CRLF fix
                                s/$CRLF//g" >$tempfile.1

            if [ -s $tempfile.1 ] ; then

                 liga=`sed '/height=20/!d
                      s/<[^>]*>//g
                      s/$/\n~s/' $tempfile.1`

                 sed  's/<[^>]*>/|/g
                       s/|*/|/g
                       s/&nbsp;//g
                       /^|1|/!d
                       s/^|//' $tempfile.1 |\

                #ENGLAND: Barclays Premiership
                # 1|Arsenal|26|19|6|1|54-18|63|2|Manchester Utd|26|18|4|4|50-14|58|3|Chelsea|26|16|7|3|38-17|55|4|Everton|26|14|5|7|41-23|47|5|Liverpool|25|11|11|3|40-17|44|6|Aston Villa|26|12|8|6|48-34|44|7|Manchester City|26|12|8|6|34-29|44|8|Portsmouth|26|11|8|7|36-26|41|9|Blackburn|26|10|9|7|32-33|39|10|West Ham|25|10|7|8|30-23|37|11|Tottenham|26|8|8|10|48-41|32|12|Middlesbrough|26|7|8|11|23-38|29|13|Newcastle|26|7|7|12|29-47|28|14|Sunderland|26|7|5|14|26-45|26|15|Bolton|26|6|7|13|26-35|25|16|Wigan|26|6|5|15|24-42|23|17|Birmingham|26|5|7|14|25-38|22|18|Reading|26|6|4|16|30-53|22|19|Fulham|26|3|10|13|25-44|19|20|Derby County|26|1|6|19|13-55|9|
                # 1    2     3  4 5 6   7    8 1     2          3   4 5 6   7    8

                awk 'BEGIN {}

                    $0 ~/^1|/ {
                                  x=split($0,feld,"|")

                                  printf("~T100~YClubs~T250P~T300W~T350D~T400L~T450FA~T500Pnt~S\n~s\n")
                                  off=50
                                  for(i=1;i<x;i++) {

                                    y++

                                    printf("~T%d %s",off,feld[i])
                                    if ( y < 2 )
                                      off=off+50
                                    if ( y == 2 )
                                      off=off+150
                                    if ( y > 2 )
                                      off=off+50

                                    if( y == 8 ) {
                                     printf("\n")
                                     off=50
                                     y=0
                                    }

                                  }

                               }
                    ' | sed "s/$home~T250/~Y$home~S~T250/
                             s/$guest~T250/~Y$guest~S~T250/" >$acttab

            fi

            if [ -s $acttab ] ; then
              button="Standing"
            else
               button=""
            fi

            # Ausgabe
            action=`$msgbox title="Details" size=26 echo=1 msg=$spieldetails_out select="Back,$button"`


            case $action in

              Back) ;;
              Standing) # falls mehr als 20 Mannschaften size=20
                        if [ `grep -c '~T50 ' $acttab` -gt 20 ] ; then
                           $msgbox title="$liga" size=20 msg=$acttab
                        else
                           $msgbox title="$liga" size=22 msg=$acttab
                        fi ;;

            esac

      else

        $msgbox title="mainmenutitle" msg='Error, could not create Details' timeout=10

      fi


}

# ------------------- MAIN -------------------------

case "$1" in

     makemainmenu) make_include
                   if [ `grep -c 'ACTION=' $ausgabe_inc` -gt 0 ] ; then
                     makemainmenu
                   else
                     $msgbox title="$mainmenutitle $tag" msg="$msgtext" timeout=10
                   fi ;;
      make_detail) make_detail $2 $3 "$4" "$5" $6 $7 "$8" ;;
          refresh) make_include ;;

esac

